// limit hue range // brightness stays same
// remove lines before zero

import processing.opengl.*;
import de.bezier.data.sql.*;
import peasy.*;

PeasyCam cam;
int MaxScale = 0;
MySQL msql;
//int [][] Veg2009 = new int[6][12];
String [] DayLabels = {
  "April 11, 2011", "April 12, 2011", "April 13, 2011", "April 14, 2011", "April 15, 2011"
};
PFont font;
int [] SixValues = new int[6];

float xRotation = 0;
float yRotation = 0;
float zRotation = 0;
float xRotationTarget = 0;
float yRotationTarget = 0;
float zRotationTarget = 0;

PFont font1 = createFont("Helvetica", 15); 
PFont font2 = createFont("Helvetica", 30);
int[][] Dewey1 = new int[1000][24];  //[dewey][hour]
int[][] Dewey2 = new int[1000][24];  
int[][] Dewey3 = new int[1000][24];  
int[][] Dewey4 = new int[1000][24];  
int[][] Dewey5 = new int[1000][24];  
int[][] tempArray = new int[1000][24];  //[dewey][hour]

//float xScalar = 0.7; 
int MaxCamDistance = 2500;
int MinCamDistance = 10;

float XScalar = 1;  
float YScalar = 400;  
float ZScalar = 0.9;  

int initialX = -1700;
int initialY = -875;
int initialZ = -161;
float initialXRot = 1.4;
float initialYRot = -0.3;
float initialZRot = 0.2;
int initialDist = 175;

int dayOfWeek = 1;

void setup() {
  //size(700,500,P3D);
  size(screen.width, screen.height, OPENGL);
  frameRate(30);
  smooth();

  //setup the camera
  cam = new PeasyCam(this, initialX, initialY, initialZ, initialDist);
  cam.setMinimumDistance(MinCamDistance);
  cam.setMaximumDistance(MaxCamDistance);
  cam.rotateX(initialXRot);
  cam.rotateY(initialYRot);
  cam.rotateZ(initialZRot);
  //  cam.lookAt(initialX,initialY,initialZ,initialDist);  

  font = createFont("Helvetica", 20); 

  //import the data from text file 1 
  String savedData1[] = loadStrings("savedData1.txt");
  println("QUERY: " + savedData1[0]);

  int curDewey = 1;
  int oldDewey = 1;
  int curHour = 0;

  for (int i=1; i < savedData1.length; i++) {
    String temp[] = split(savedData1[i], ",");
    curDewey = Integer.parseInt(temp[0]);
    curHour = Integer.parseInt(temp[1]);
    tempArray[curDewey][curHour]=Integer.parseInt(temp[2]);
    Dewey1[curDewey][curHour]=Dewey1[curDewey][curHour]+tempArray[curDewey][curHour]; // sum values    

    if (Dewey1[curDewey][curHour] >  MaxScale) {
      MaxScale = Dewey1[curDewey][curHour];
    }
  }

  //import the data from text file 2 
  String savedData2[] = loadStrings("savedData2.txt");
  println("QUERY: " + savedData2[0]);

  curDewey = 1;
  oldDewey = 1;
  curHour = 0;

  for (int i=1; i < savedData2.length; i++) {
    String temp[] = split(savedData2[i], ",");
    curDewey = Integer.parseInt(temp[0]);
    curHour = Integer.parseInt(temp[1]);
    tempArray[curDewey][curHour]=Integer.parseInt(temp[2]);
    Dewey2[curDewey][curHour]=Dewey2[curDewey][curHour]+tempArray[curDewey][curHour]; // sum values    

    if (Dewey2[curDewey][curHour] >  MaxScale) {
      MaxScale = Dewey2[curDewey][curHour];
    }
  }

  //import the data from text file 3 
  String savedData3[] = loadStrings("savedData3.txt");
  println("QUERY: " + savedData3[0]);

  curDewey = 1;
  oldDewey = 1;
  curHour = 0;

  for (int i=1; i < savedData3.length; i++) {
    String temp[] = split(savedData3[i], ",");
    curDewey = Integer.parseInt(temp[0]);
    curHour = Integer.parseInt(temp[1]);
    tempArray[curDewey][curHour]=Integer.parseInt(temp[2]);
    Dewey3[curDewey][curHour]=Dewey3[curDewey][curHour]+tempArray[curDewey][curHour]; // sum values    

    if (Dewey3[curDewey][curHour] >  MaxScale) {
      MaxScale = Dewey3[curDewey][curHour];
    }
  }

  //import the data from text file 4 
  String savedData4[] = loadStrings("savedData4.txt");
  println("QUERY: " + savedData4[0]);

  curDewey = 1;
  oldDewey = 1;
  curHour = 0;

  for (int i=1; i < savedData4.length; i++) {
    String temp[] = split(savedData4[i], ",");
    curDewey = Integer.parseInt(temp[0]);
    curHour = Integer.parseInt(temp[1]);
    tempArray[curDewey][curHour]=Integer.parseInt(temp[2]);
    Dewey4[curDewey][curHour]=Dewey4[curDewey][curHour]+tempArray[curDewey][curHour]; // sum values    

    if (Dewey4[curDewey][curHour] >  MaxScale) {
      MaxScale = Dewey4[curDewey][curHour];
    }
  }

  //import the data from text file 5 
  String savedData5[] = loadStrings("savedData5.txt");
  println("QUERY: " + savedData5[0]);

  curDewey = 1;
  oldDewey = 1;
  curHour = 0;

  for (int i=1; i < savedData5.length; i++) {
    String temp[] = split(savedData5[i], ",");
    curDewey = Integer.parseInt(temp[0]);
    curHour = Integer.parseInt(temp[1]);
    tempArray[curDewey][curHour]=Integer.parseInt(temp[2]);
    Dewey5[curDewey][curHour]=Dewey5[curDewey][curHour]+tempArray[curDewey][curHour]; // sum values    

    if (Dewey5[curDewey][curHour] >  MaxScale) {
      MaxScale = Dewey5[curDewey][curHour];
    }
  }
}


void draw() {
  background(0);

  //lighting
  /*
  float dirY = (mouseY / float(height) - 0.5) * 2;
   float dirX = (mouseX / float(width) - 0.5) * 2;
   directionalLight(200, 120, 200, -dirX, -dirY, -1);
   */

  draw3DSpatialMap();

  //use HUD to write stuff that is stationary in relation to the camera
  cam.beginHUD();
  textAlign(LEFT, CENTER);
  fill(98);
  text("Seattle Public Library", 20, 18);
  textSize(16);
  text("Checkout Transactions by Dewey Category Per Hour", 20, 40);
  text("Week of April 11-15, 2011", 20, 60);
  textAlign(RIGHT, CENTER);
  text("April 1"+dayOfWeek, width-20, height-20);
  textAlign(LEFT, CENTER);
  /*
  text("xRotation: " + xRotationTarget + " yRotation: " + yRotationTarget + " zRotation: " + zRotationTarget, 150, 60);
   text("xPosition: " + cam.getPosition()[0] + " yPosition: " + cam.getPosition()[1] + " zPosition: " + cam.getPosition()[2], 150, 80);
   text("distance: " + cam.getDistance(), 150, 100);
   */

  cam.endHUD();
}


void draw3DSpatialMap() {
  float Xside;
  float Yside;
  float Zside;
  //background(255, 120, 50); //peachy color 
  strokeWeight(1); 
  Xside = 1.5;
  Yside = 100;
  Zside = 20;

  stroke(220, 20, 55); //220,210,5

    colorMode(HSB, 100);
  float newHue = 0;
  if (dayOfWeek == 1) {
    for (int h=7; h<22; h++) {
      for (int d=0;d<1000;d++) {
        float NewHeight = map(sqrt(sqrt(Dewey1[d][h])), 0, MaxScale, 0, Yside*YScalar);
        pushMatrix();
        translate(d*Xside*XScalar-2000, Yside-NewHeight/2.0, -1*Zside*h);

        if (NewHeight > 0)
        {
          newHue = map(NewHeight, 0, MaxScale, 0, 200);
          fill(newHue, 100, 100); //160,180,240,120
          box(Xside*.95, NewHeight, Zside*ZScalar*.95);
        }

        popMatrix();
      }
    }
  }
  else if (dayOfWeek == 2) {
    for (int h=7; h<22; h++) {
      for (int d=0;d<1000;d++) {
        float NewHeight = map(sqrt(sqrt(Dewey2[d][h])), 0, MaxScale, 0, Yside*YScalar);
        pushMatrix();
        translate(d*Xside*XScalar-2000, Yside-NewHeight/2.0, -1*Zside*h);
        if (NewHeight > 0)
        {
          newHue = map(NewHeight, 0, MaxScale, 0, 250);
          //        newHue = map(NewHeight, 0, MaxScale, 0, 50);  // orange 
          fill(newHue, 100, 100); //160,180,240,120
          box(Xside*.95, NewHeight, Zside*ZScalar*.95);
        }
        popMatrix();
      }
    }
  }
  else if (dayOfWeek == 3) {
    for (int h=7; h<22; h++) {
      for (int d=0;d<1000;d++) {
        float NewHeight = map(sqrt(sqrt(Dewey3[d][h])), 0, MaxScale, 0, Yside*YScalar);
        pushMatrix();
        translate(d*Xside*XScalar-2000, Yside-NewHeight/2.0, -1*Zside*h);
        if (NewHeight > 0)
        {
          newHue = map(NewHeight, 0, MaxScale, 0, 250);
          //        newHue = map(NewHeight, 0, MaxScale, 0, 50);  // orange 
          fill(newHue, 100, 100); //160,180,240,120
          box(Xside*.95, NewHeight, Zside*ZScalar*.95);
        }
        popMatrix();
      }
    }
  }
  else if (dayOfWeek == 4) {
    for (int h=7; h<22; h++) {
      for (int d=0;d<1000;d++) {
        float NewHeight = map(sqrt(sqrt(Dewey4[d][h])), 0, MaxScale, 0, Yside*YScalar);
        pushMatrix();
        translate(d*Xside*XScalar-2000, Yside-NewHeight/2.0, -1*Zside*h);
        if (NewHeight > 0)
        {
          newHue = map(NewHeight, 0, MaxScale, 0, 250);
          //        newHue = map(NewHeight, 0, MaxScale, 0, 50);  // orange 
          fill(newHue, 100, 100); //160,180,240,120
          box(Xside*.95, NewHeight, Zside*ZScalar*.95);
        }
        popMatrix();
      }
    }
  }
  else if (dayOfWeek == 5) {
    for (int h=7; h<22; h++) {
      for (int d=0;d<1000;d++) {
        float NewHeight = map(sqrt(sqrt(Dewey5[d][h])), 0, MaxScale, 0, Yside*YScalar);
        pushMatrix();
        translate(d*Xside*XScalar-2000, Yside-NewHeight/2.0, -1*Zside*h);
        if (NewHeight > 0)
        {
          newHue = map(NewHeight, 0, MaxScale, 0, 250);
          //        newHue = map(NewHeight, 0, MaxScale, 0, 50);  // orange 
          fill(newHue, 100, 100); //160,180,240,120
          box(Xside*.95, NewHeight, Zside*ZScalar*.95);
        }
        popMatrix();
      }
    }
  }

  // Draw Grid and Labels
  textFont(font); 
  fill(98);

  //Dewey Categories (horizontal)
  for (int d =0;d<=1000;d++) {
    if (d % 100 == 0)
    {
      textAlign(CENTER, TOP);
      pushMatrix();
      textSize(50);
      translate(d*Xside-2000, Yside, -100);
      rotateX(PI/2.0);
      text(d, 0, 0);
      strokeWeight(1.0);
      line(0, -286, 0, -45);
      popMatrix();
    }
  }

  textFont(font); 
  textSize(20);
  // Hours (vertical)
  for (int i = 7;i<21;i++) {
    textAlign(LEFT, TOP);
    pushMatrix();

    rotateX(PI/2.0);
    translate(-2100, -i*20, -100);
    if (i<20)
    {
      line(100, -5, 1596, -5);
    } 
    strokeWeight(1.0);

    if (i<=11) {
      text("a.m.", -3, -5);
    }
    if (i>11) {
      text("p.m.", -3, -5);
    }
    if (i==12) {
      strokeWeight(3.0);
      line(100, -5, 1500, -5); 
      strokeWeight(1.0);
    }
    if (i>12) {
      text(i-12, -40, 0);
    }
    else {
      text(i, -40, 0);
    }
    popMatrix();
  }
}


void keyPressed() {
  if (key == ' ') {
    cam.reset(0);

    cam.rotateX(initialXRot);
    cam.rotateY(initialYRot);
    cam.rotateZ(initialZRot);
    cam.lookAt(initialX, initialY, initialZ, 100);
  
    cam.setDistance(initialDist);
  } 

  if (key == 'x') {
    cam.rotateX(0.1);
  } 

  if (key == 'c') {
    cam.rotateX(-0.1);
  } 
  if (key == 'y') {
    cam.rotateY(0.1);
  } 
  if (key == 'b') {
    cam.rotateY(-0.1);
  } 

  if (key == 'z') {
    cam.rotateZ(0.1);
  } 

  if (key == 'a') {
    cam.rotateZ(-0.1);
  } 
  if (key == '-') {
    cam.setDistance(cam.getDistance()+MaxCamDistance/10);
  } 

  if (key == '=') {
    cam.setDistance(cam.getDistance()/10);
  } 

  if (key == '1') {
    dayOfWeek = 1;
  }
  if (key == '2') {
    dayOfWeek = 2;
  }
  if (key == '3') {
    dayOfWeek = 3;
  }
  if (key == '4') {
    dayOfWeek = 4;
  }
  if (key == '5') {
    dayOfWeek = 5;
  }
  if (key == '6') {
    cam.reset(0);

    cam.rotateX(1.1);
    cam.rotateY(-0.24);
    cam.rotateZ(0.2);

    cam.lookAt(-1700, -875, 161, 100);  
    cam.setDistance(10);
  }
  if (key == '7') {
    cam.reset(0);

    cam.rotateX(1.37);
    cam.rotateY(-1.05);
    cam.rotateZ(-0.11);

    cam.lookAt(-2485, -538, -236, 100);  
    cam.setDistance(10);
  }
  if (key == '8') {
    cam.reset(0);

    cam.rotateX(1.6);
    cam.rotateY(-0.28);
    cam.rotateZ(0.02);

    cam.lookAt(-1753, -1060, -115, 100);  
    cam.setDistance(10);
  }

  if (key == '9') {
    cam.reset(0);

    cam.rotateX(2.4);
    cam.rotateY(-1.18);
    cam.rotateZ(2.45);

    cam.lookAt(-2300, 0, -335, 100);  
    cam.setDistance(100);
  }
  if (key == '0') {
    cam.reset(0);

    cam.rotateX(0.3);
    cam.rotateY(0);
    cam.rotateZ(0);
    cam.lookAt(-1300, -700, 915, 100);  
    cam.setDistance(10);
  }
  if (key == 'p') {
    cam.rotateY(PI/4.0);
  }
  if (key == 'f') {
    cam.reset(0);

    cam.rotateX(3.0);
    cam.rotateY(-1.4);
    cam.rotateZ(-3.0);
    cam.lookAt(-200, 20, -15, 100);  
    cam.setDistance(1700);
  }
}

void mouseReleased() {
  float[] rotations = cam.getRotations();
  xRotation = rotations[0];
  yRotation = rotations[1];
  zRotation = rotations[2];
  xRotationTarget = rotations[0];
  yRotationTarget = rotations[1];
  zRotationTarget = rotations[2];
}

